module Delivery where

type Weight = Integer
type Graph n = Node n
data Node n = N n [Edge n]
data Edge n = E Weight (Node n)

instance Eq n=> Eq (Node n) where
  N n1 _ == N n2 _ = n1 == n2

data Path a = P { cost :: Integer, path :: [a] } deriving (Eq, Show)

------------
-- A3.1.2 --
------------

add :: Path a -> Integer -> a -> Path a
add = undefined

contains :: Eq a => Path a -> a -> Bool
contains = undefined


------------
-- A3.1.3 --
------------

cycles :: Eq n => Node n -> [Path n]
cycles = undefined

------------
-- A3.1.4 --
------------

nodes :: Eq n => Node n -> [n]
nodes = undefined

numNodes :: Eq n => Node n -> Int
numNodes = undefined

------------
-- A3.1.5 --
------------

tpp :: Eq n => Node n -> Maybe (Path n)
tpp = undefined
